-- Global Variables
combatstarttime = nil;

--Buff table:
-- starttime
-- overlaptotal
-- total
-- tickable
-- ticks
-- 
--]
sr = { };
rip = { };
rake = { };
mangle = { };
SRTOTALTIME = 0;
-- When the AddOn loads...
function CatFight_OnLoad(self)
	-- Register the game events neccesary for our functionality
	self:RegisterEvent("PLAYER_REGEN_DISABLED");		-- Entering Combat
	self:RegisterEvent("PLAYER_REGEN_ENABLED");		-- Leaving Combat
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");

	self:RegisterEvent("SPELL_AURA_APPLIED");			-- Buff/Debuff Applied
	self:RegisterEvent("SPELL_AURA_REMOVED");			-- Buff/Debuff Removed
end

-- Based upon our registered events, we want different things to happen when each event occurs.
function CatFight_OnEvent(self, event, ...)

	
	-- Entering Combat
	if ( event == "PLAYER_REGEN_DISABLED") then
		combatstarttime = time();
		sr.total = 0;
		sr.overlap = 0;
		rake.total = 0;
		rake.overlap = 0;
		rip.total = 0;
		rip.overlap = 0;
		mangle.total = 0;
		mangle.overlap = 0;
		
		if(sr.starttime ~= nil and sr.starttime < combatstarttime) then
			sr.starttime = combatstarttime;
		end
		if(rake.starttime ~= nil and rake.starttime < combatstarttime) then
			rake.starttime = combatstarttime;
		end
		if(rip.starttime ~= nil and rip.starttime < combatstarttime) then
			rip.starttime = combatstarttime;
		end
		if(mangle.starttime ~= nil and mangle.starttime < combatstarttime) then
			mangle.starttime = combatstarttime;
		end
		DEFAULT_CHAT_FRAME:AddMessage("Entering combat.",0.8,0.8,1);
		return;
	end
	if ( event == "PLAYER_REGEN_ENABLED") then
		if(combatstarttime == nil) then
			DEFAULT_CHAT_FRAME:AddMessage("Error: No start time available.",0.8,0.8,1);
			return;
		end
		local endtime = time();
		
		if(sr.starttime ~= nil) then
			sr.total = sr.total + endtime - sr.starttime;
		end
		sr.uptimeRatio = round(100 * sr.total / (endtime - combatstarttime),2);
		if(sr.total == 0) then
			sr.overlapRatio = 0;
		else
			sr.overlapRatio = round(100 * sr.overlap / sr.total,2);
		end
		
		if(rip.starttime ~= nil) then
			rip.total = rip.total + endtime - rip.starttime;
		end
		rip.uptimeRatio = round(100 * rip.total / (endtime - combatstarttime),2);
		if(rip.total == 0) then
			rip.overlapRatio = 0;
		else
			rip.overlapRatio = round(100 * rip.overlap / rip.total,2);
		end
		
		if(rake.starttime ~= nil) then
			rake.total = rake.total + endtime - rake.starttime;
		end
		rake.uptimeRatio = round(100 * rake.total / (endtime - combatstarttime),2);
		if(rake.total == 0) then
			rake.overlapRatio = 0;
		else
			rake.overlapRatio = round(100 * rake.overlap / rake.total,2);
		end
		
		if(mangle.starttime ~= nil) then
			mangle.total = mangle.total + endtime - mangle.starttime;
		end
		mangle.uptimeRatio = round(100 * mangle.total / (endtime - combatstarttime),2);
		if(mangle.total == 0) then
			mangle.overlapRatio = 0;
		else
			mangle.overlapRatio = round(100 * mangle.overlap / mangle.total,2);
		end
		
		DEFAULT_CHAT_FRAME:AddMessage("Combat ended. Time = " .. endtime, 0.8, 0.8, 1);
		DEFAULT_CHAT_FRAME:AddMessage("Time Elapsed: " .. (endtime - combatstarttime) .. " seconds.", 0.8,0.8,1);
		DEFAULT_CHAT_FRAME:AddMessage("Mangle Uptime: " .. mangle.uptimeRatio .. 
												"% Mangle Overlap: " .. mangle.overlapRatio .. "%", 0.8,0.8,1);
		DEFAULT_CHAT_FRAME:AddMessage("Rake Uptime: " .. rake.uptimeRatio .. 
												"% Rake Overlap: " .. rake.overlapRatio .. "%", 0.8,0.8,1);
		DEFAULT_CHAT_FRAME:AddMessage("Savage Roar Uptime: " .. sr.uptimeRatio .. 
												"% Savage Roar Overlap: " .. sr.overlapRatio .. "%", 0.8,0.8,1);
		DEFAULT_CHAT_FRAME:AddMessage("Rip Uptime: " .. rip.uptimeRatio ..
												"% Rip Overlap: " .. rip.overlapRatio .. "%", 0.8,0.8,1);
		
		combatstarttime = nil;
		
		return;
	end
	
	if ( event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local message = ""
		for i=1, 15 do
			local arg = select(i, ...);
			if(arg)then
				message = message .. arg .. ", ";
			else
				message = message .. "nil, ";
			end
		end
		ChatFrame4:AddMessage(message);
		local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...);
		local getTimeStamp = GetTime();
		
		if ( type == "SPELL_AURA_APPLIED") then
			-- Only parse combat events sourcing from the player.
			if(sourceGUID ~= UnitGUID("player")) then
				return;
			end;
			local spellId, spellName, spellSchool, auraType = select(9, ...);
			if(auraType == "BUFF") then
				if(spellName == "Savage Roar") then
					sr.starttime = timestamp;
					sr.expiretime = select(7, UnitAura("player","Savage Roar"));
					return;
				end
			end
			if(auraType == "DEBUFF") then
				if(spellName == "Rip") then
					rip.starttime = timestamp;
					rip.expiretime = select(7, UnitDebuff("target","Rip"));
					return;
				end
				if(spellName == "Rake") then
					rake.starttime = timestamp;
					rake.expiretime = select(7, UnitDebuff("target","Rake"));
					return;
				end
				if(spellName == "Mangle - Cat") then
					mangle.starttime = timestamp;
					mangle.expiretime = select(7, UnitDebuff("target","Mangle - Cat"));
					return;
				end
			end
			return;
		end
		if ( type == "SPELL_AURA_REMOVED") then
			-- Only parse combat events sourcing from the player.
			if(sourceGUID ~= UnitGUID("player")) then
				return;
			end;
			local spellId, spellName, spellSchool, auraType = select(9, ...);
			if(auraType == "BUFF") then
				if(sr.starttime == nil)then return end
				if(spellName == "Savage Roar") then
					local endtime = timestamp;
					sr.total = sr.total + (endtime - sr.starttime);
					sr.starttime = nil;
					return;
				end
			end
			
			if(auraType == "DEBUFF") then
				local endtime = timestamp;
					
				if(spellName == "Rip" and rip.starttime) then
					rip.total = rip.total + (endtime - rip.starttime);
					rip.starttime = nil;
				end
				if(spellName == "Rake" and rake.starttime) then
					rake.total = rake.total + (endtime - rake.starttime);
					rake.starttime = nil;
				end
				if(spellName == "Mangle - Cat" and mangle.starttime) then
					mangle.total = mangle.total + (endtime - mangle.starttime);
					mangle.starttime = nil;
				end
				return;
			end
		end
		if(type == "SPELL_AURA_REFRESH") then
			-- Only parse combat events sourcing from the player.
			local spellId, spellName, spellSchool, auraType = select(9, ...);
			if(auraType == "BUFF") then
				if(spellName == "Savage Roar" and destGUID == UnitGUID("player")) then
					if(not sr.expiretime) then return end
					
					local overlap = sr.expiretime - GetTime();
					if(overlap < 0) then
						return;
					end
					sr.overlap = sr.overlap + overlap;
				end
			end
		end
		if(type == "SPELL_CAST_SUCCESS") then
			local spellId, spellName, spellSchool, auraType = select(9, ...);
			if(spellName == "Rip" and rip.starttime)then
				local overlap = rip.expiretime - GetTime();
				if(overlap < 0) then
					return;
				end
				rip.overlap = rip.overlap + overlap;
				rip.lastOverlapTime = GetTime();
				rip.lastOverlapAmount = overlap;
				rip.expiretime = GetTime() + select(6, UnitDebuff("target", "Rip"));
				rip.refresh = false;
			end
			if(spellName == "Rake" and rake.starttime)then
				local overlap = rake.expiretime - GetTime();
				if(overlap < 0) then
					return;
				end
				rake.overlap = rake.overlap + overlap;
				rake.lastOverlapTime = GetTime();
				rake.lastOverlapAmount = overlap;
				rake.expiretime = GetTime() + select(6, UnitDebuff("target", "Rake"));
				rake.refresh = false;
			end
			if(spellName == "Mangle - Cat" and mangle.starttime)then
				local overlap = mangle.expiretime - GetTime();
				if(overlap < 0) then
					return;
				end
				mangle.overlap = mangle.overlap + overlap;
				mangle.lastOverlapTime = GetTime();
				mangle.lastOverlapAmount = overlap;
				mangle.expiretime = GetTime() + select(6, UnitDebuff("target", "Mangle - Cat"));
				mangle.refresh = false;
			end
		end
		if(type == "SPELL_MISSED") then
			local spellId, spellName, spellSchool, auraType = select(9, ...);
			
			if(spellName == "Rip" and rip.starttime) then
				if(rip.lastOverlapTime == nil) then
					rip.missed = true;
					return;
				end;
				local elapsed = GetTime() - rip.lastOverlapTime;
				if(elapsed > .75 )then
					rip.missed = true;
					return;
				end
				
				rip.overlap = rip.overlap - rip.lastOverlapAmount;
				rip.lastOverlapTime = nil;
				rip.lastOverlapAmount = 0;
			end
			
			if(spellName == "Rake" and rake.starttime) then
				if(rake.lastOverlapTime == nil) then
					rake.missed = true;
					return;
				end;
				local elapsed = GetTime() - rake.lastOverlapTime;
				if(elapsed > .75 )then
					rake.missed = true;
					return;
				end
				
				rake.overlap = rake.overlap - rake.lastOverlapAmount;
				rake.lastOverlapTime = nil;
				rake.lastOverlapAmount = 0;
			end
			
			if(spellName == "Mangle - Cat" and mangle.starttime) then
				
				DEFAULT_CHAT_FRAME:AddMessage("Mangle missed: " .. GetTime() .. " last overlap time = " .. mangle.lastOverlapTime .. " last overlap amount = " .. mangle.lastOverlapAmount);
				if(mangle.lastOverlapTime == nil) then
					mangle.missed = true;
					return;
				end;
				local elapsed = GetTime() - mangle.lastOverlapTime;
				
				if(elapsed > .75 )then
					mangle.missed = true;
					return;
				end
				
				mangle.overlap = mangle.overlap - mangle.lastOverlapAmount;
				mangle.lastOverlapTime = nil;
				mangle.lastOverlapAmount = 0;
			end
				
		end
		
	end
end
function round(num, idp)
  return tonumber(string.format("%." .. (idp or 0) .. "f", num))
end
